Mantis Bug Tracker

View Issue Details Jump to Notes ] Issue History ] Print ]
IDProjectCategoryView StatusDate SubmittedLast Update
0008899opensim[GRID] Other Servicepublic2021-06-08 10:172021-09-29 10:45
ReporterKubwa 
Assigned To 
PriorityhighSeverityminorReproducibilityalways
StatusnewResolutionopen 
PlatformAll plattformsOperating SystemAll operating systemsOperating System VersionAll versions
Product Version0.9.1.0 
Target VersionFixed in Version 
Summary0008899: Vivox voice will be discontinued
DescriptionDue to the fact that vivox voice will be discontinued and turned offline in the future, we need an alternative voice module with the same functionality as vivox.

Mumble voice is no longer developed and Freeswitch is no alternative due to its massive lack of features (eg. no single agents are listed and can be controlled seperately in volume).

This is a "bug" which should be worked on, otherwise opensim voice will die with vivox service turned offline.
Steps To ReproduceUse Vivox voice
TagsNo tags attached.
Git Revision or version number
Run ModeStandalone (1 Region) , Standalone (Multiple Regions) , Grid (1 Region per Sim) , Grid (Multiple Regions per Sim)
Physics EngineBasicPhysics, ODE, BulletSim, ubODE, Other
Script EngineXEngine, YEngine
EnvironmentUnknown, Mono / Linux32, Mono / Linux64, Mono / Windows, Mono / OSX, .NET / Windows32, .NET / Windows64
Mono Version3.2
ViewerAll viewers
Attached Files

- Relationships

-  Notes
(0037812)
piusnoel (reporter)
2021-06-09 06:24

From my point of view this is primarily a viewer side problem that requires to involve TPV developers.

Some facts and thoughts:

1) Vivox (now part of Unity) officially no longer accepts new registrations for its free Virtual World Voice Service since May 25, 2021.

It's now been clearly communicated on the previous registration page at https://opensim.vivox.com/opensim/. [^]

For previous users, the free service and support will continue for the time being.

2) Vivox's paid services will continue to run.

3) However, the Secondlife Viewer depends on a library from Vivox which is no longer supported on Linux. Vivox officially dropped support for Linux some time ago. At about the same time Linden Lab dropped Linux support for its SL viewer.

4) I dont no why, but currently on my Linux PC voice no longer works. I tried with the latest Firestorm using OpenSim and Secondlife. Back in March 2021 it still worked. Between March and today I upgraded Linux from Ubuntu 20.04 to Ubuntu 21.04. It might be a simple configuration issue, but I'm in doubt.

Before March 2011, the Vivox library for Linux still worked for me, at least with my selfcompiled Firestorm releases.

Newer versions of Firestorm for Windows already use not the latest, but a newer Vivox version of the library which is no longer available under Linux.

I'm afraid it's only a matter of time before older versions definitely stop working.

5) I can't say much about the viewer-side implementation of Vivox or other voice services.

I read once that the developers are not interested in implementing other voice services as doing so would break the TPV Shared Experience rules.

I think that's nonsense, especially since there is already a separation between SL and Opensim today.

6) I never managed to get Freeswitch running. I also have no clue how it is implemented in the viewers.

I've given up to get it up and running.

However, it has been done by others and that sounds to me like it's possible.

7) If a cooperation with the TPV developers can be found, then I dont consider the server-side implementation to be problematic.

Today, the Vivox implementation is some 1300 lines of code.

If the external services provide a well defined web service API, something similar to Vivox, then it should be possible to implement it in the Simulator within a reasonable amount of time.

Personally, I would be happy to contribute some work on this project.

Now the big question: what would be alternatives that could be integrated and how to get TPV developers on board?
(0037813)
tampa (reporter)
2021-06-09 06:27

http://opensimulator.org/wiki/Chat_log_from_the_meeting_on_2021-06-08 [^]
(0037814)
Kubwa (reporter)
2021-06-09 06:29

The problem is not just the viewer implementation but also the server implementation. Maybe both have to change something.

Freeswitch is working, yeah, i managed to setup it myself some time ago, but the user experience is very bad.

http://opensimulator.org/wiki/Freeswitch_Module [^]
See sections "issues" and "notes".
(0037815)
JeffKelley (reporter)
2021-06-09 06:57

THALES and VCOMM are supposed to ressurect a Mumble-based solution.
https://www.slideshare.net/LisaLaxton/oscc19-vo-ip05 [^]
(0037816)
piusnoel (reporter)
2021-06-09 07:39

Thank you tampa for the link to the meeting chat log. As I have a developer account I also considered to use the free dev portal to create a project for 10000 concurrent users mentioned by Bill. I'n addition the dev portal provides fairly good documentation about the client and server communication processes involved.

Hovever, as a Linux desktop user I'm looking for a solution that will support Linux as well on the long run.
(0037817)
piusnoel (reporter)
2021-06-09 11:52

If correctly configured and setup Vivox still works on Ubuntu 21.04 with the Opensim Linux Firestorm 6.4.13 (63251). It's using Vivox server 3.2.0002.10426.
I had to reinstall some libraries (those mentioned on the Firestorm downloads site for Ubuntu 18.04) and guvcview needed for the mic I use from my web cam.
Btw, I dont use WINE (often recommended for Firestorm).
(0037818)
UbitUmarov (administrator)
2021-06-11 15:03

i managed to install freeswitch on windows to give it a little try.
well config is a bit confusing, both opensim and freesw sides
it is a waste to load any other codec other than PCMU for opensim use
also a lot of other modules are just not needed
our wiki is just not that good on that.

firestorm 6.4.13 will not work, unless we do downgrade its SLVoice to version 4.6, i did that by just c&p older files, ofc breaking my install for sl use.
That 4.6 is the version shipped with fs for linux, reason why pius seen it working.

singu 1.8.7 just did a mess with voice and control IPs, so failed

fs shown strange this on "Nearby Voice", possible volume controls do nothing, but i didn't test that much with just one alt.
(0037819)
tampa (reporter)
2021-06-11 18:17
edited on: 2021-06-11 23:20

Looking around a bit I found some stuff:

https://www.codeproject.com/Articles/482735/TCP-Audio-Streamer-and-Player-Voice-Chat-over-IP [^]
https://github.com/notdef1ned/voice-chat [^]
https://www.codeproject.com/Articles/58865/Voice-and-Text-Conferencing-Library [^]

But that requires work still.

I see two options going forward.

a. Implement a new system in both OpenSim and viewers
b. Reverse engineer the protocol and build a backend to suit

Both are a considerable amount of work and unless one of us decides to just knuckle down and get it done it will take quite some time or not happen at all. This inevitably brings us to the question of whether this is an issue that requires funding to resolve.

(0037820)
djphil (reporter)
2021-06-12 02:44

whisper_server (Aurora) @ https://github.com/aurora-sim/whisper_server [^]
whisper_server (Forked From) @https://github.com/vgaessler/whisper_server [^]
MurmurVoice-opensim @ https://github.com/UbitUmarov/MurmurVoice-opensim [^]

If it worked in the past I imagine that with a proper update it could still work today.
(0037821)
UbitUmarov (administrator)
2021-06-12 04:17

Yes djphil, but it is now very outdated, in particular the viewer side code.
The opensim server side would be easy for me or anyone to update.

IMA/Thales/Seth EchoVoice (mentioned above by JeffKelly and others) is basically a update and improvement on that old mumble.

I asked Lisa about its state and possible integration on opensim and then start work talking with viewer devs to support it.
(0037822)
djphil (reporter)
2021-06-12 04:21

That would be a good thing, in my memory the sound was really good quality with this system and the configuration simple for the users, quite the opposite of Freeswitch.
(0037823)
UbitUmarov (administrator)
2021-06-12 04:26

A major issue on this is that, to have several solutions like before (when they did work) may sound great, when in fact it is NOT.

With the exception of few use cases on their closed grids, majority of opensim must use the same system, or it will be impossible to keep TVPs devs support, or even ppl talking to each other across the board.
(0037824)
Kubwa (reporter)
2021-06-12 08:06

It would be amazing if murmur could be used as voice in opensim.
(0037825)
beqjanus (reporter)
2021-06-15 06:59

The so-called EchoVoice solution from IMA/Thales seems the best bet, the concern is that it does not appear to be transparently open source but I may be looking for the wrong thing. I suspect that the name will have to change as EchoVoice is a registered trademark in any case.

The voice bridge concept is interesting as it allows newer voice solutions to be "injected" into the older viewers (though I believe that the API between viewer and SLVoice is changing at the moment and would no doubt change again with any future Vivox5 updates in SL). The bridge also allows switching to occur based on region/grid support which would address one of the issues that makes migratingto Vivox5 hard in the first place.
(0037826)
tampa (reporter)
2021-06-15 09:11

The problem with that "solution" is that at the moment as far as I can see it's a concept with some snippets of code perhaps. It would need to further developed and that's unlikely to come from IMA given the track record of contributions doesn't exactly litter the git history.

Mumble itself has the issue that the development has been somewhat slow and the direction of it is not clear. If it were made the basis of a voice solution it would likely have to be based on a snapshot in time rather than maintaining compatibility with their releases. That then brings us back to the issue of creating solutions that eventually may stop working due to circumstances beyond our control, requiring either large updates or new solutions altogether a second time round.

All too often the underlying frameworks or used libraries stop working due to lack of development or security flaws. The resulting incompatibility or security risks mean whatever basis voice will use should be as lightweight as possible and use parts that otherwise have a future and have some guarantee to get security updates as needed. I'm not entirely seeing that with Mumble, but that's just intuition so perhaps that worry is unwarranted.

It's nice to see we have the viewer support for making a potential breaking change though, that means the solution will work with the viewer. That just leaves the matter of figuring out what to do and who'll be the lucky soul to write it :)
(0037971)
Kubwa (reporter)
2021-09-19 01:37

Are there any updates on this problem?
(0037972)
tampa (reporter)
2021-09-19 02:25

Only thing I can report is that I have contacted some people to see if any one of them can reverse engineer the current protocol in hopes of a more drop-in replacement rather than re-engineering both viewer and server, but results are not yet in. Still trying to raise a bounty for a solution as well.
(0037975)
vladimir Djannovic (reporter)
2021-09-29 10:45

it may be old and it may not work anymore but to dig ....
https://github.com/zaki/slvoice [^]

- Issue History
Date Modified Username Field Change
2021-06-08 10:17 Kubwa New Issue
2021-06-08 10:18 Kubwa Environment Unknown, Mono / Linux32, Mono / Linux64, Mono / Windows, Mono / OSX => Unknown, Mono / Linux32, Mono / Linux64, Mono / Windows, Mono / OSX, .NET / Windows32, .NET / Windows64
2021-06-08 10:18 Kubwa Summary Vivox voice will be discintinued => Vivox voice will be discontinued
2021-06-08 10:19 Kubwa Description Updated View Revisions
2021-06-09 06:24 piusnoel Note Added: 0037812
2021-06-09 06:27 tampa Note Added: 0037813
2021-06-09 06:29 Kubwa Note Added: 0037814
2021-06-09 06:57 JeffKelley Note Added: 0037815
2021-06-09 07:39 piusnoel Note Added: 0037816
2021-06-09 11:52 piusnoel Note Added: 0037817
2021-06-11 15:03 UbitUmarov Note Added: 0037818
2021-06-11 18:17 tampa Note Added: 0037819
2021-06-11 23:20 tampa Note Edited: 0037819 View Revisions
2021-06-12 02:44 djphil Note Added: 0037820
2021-06-12 04:17 UbitUmarov Note Added: 0037821
2021-06-12 04:21 djphil Note Added: 0037822
2021-06-12 04:26 UbitUmarov Note Added: 0037823
2021-06-12 08:06 Kubwa Note Added: 0037824
2021-06-15 06:59 beqjanus Note Added: 0037825
2021-06-15 09:11 tampa Note Added: 0037826
2021-09-19 01:37 Kubwa Note Added: 0037971
2021-09-19 02:25 tampa Note Added: 0037972
2021-09-29 10:45 vladimir Djannovic Note Added: 0037975


Copyright © 2000 - 2012 MantisBT Group
Powered by Mantis Bugtracker